--- /home/monnier/work/xemacs/src/regex.c	Thu Dec 14 17:15:15 2000
+++ src/regex.c.1.138	Thu Apr 26 09:32:57 2001
@@ -1485,114 +1621,67 @@
   while (0)
 
 /* Registers are set to a sentinel when they haven't yet matched.  */
-static unsigned char reg_unset_dummy;
+static char reg_unset_dummy;
 #define REG_UNSET_VALUE (&reg_unset_dummy)
 #define REG_UNSET(e) ((e) == REG_UNSET_VALUE)
 
 /* Subroutine declarations and macros for regex_compile.  */
 
+static void store_op1 (), store_op2 ();
+static void insert_op1 (), insert_op2 ();
+static boolean at_begline_loc_p (), at_endline_loc_p ();
+static boolean group_in_compile_stack ();
+static reg_errcode_t compile_range ();
+
 /* Fetch the next character in the uncompiled pattern---translating it
    if necessary.  Also cast from a signed character in the constant
    string passed to us by the user to an unsigned char that we can use
    as an array index (in, e.g., `translate').  */
+#ifndef PATFETCH
 #define PATFETCH(c)							\
-  do {									\
-    PATFETCH_RAW (c);							\
-    c = TRANSLATE (c);							\
+  do {if (p == pend) return REG_EEND;					\
+    c = (unsigned char) *p++;						\
+    if (RE_TRANSLATE_P (translate)) c = RE_TRANSLATE (translate, c);	\
   } while (0)
+#endif
 
 /* Fetch the next character in the uncompiled pattern, with no
-   translation.  */
+   translation.	 */
 #define PATFETCH_RAW(c)							\
   do {if (p == pend) return REG_EEND;					\
-    assert (p < pend);							\
-    c = charptr_emchar (p); 						\
-    INC_CHARPTR (p);							\
+    c = (unsigned char) *p++;						\
   } while (0)
 
 /* Go backwards one character in the pattern.  */
-#define PATUNFETCH DEC_CHARPTR (p)
-
-#ifdef MULE
+#define PATUNFETCH p--
 
-#define PATFETCH_EXTENDED(emch)						\
-  do {if (p == pend) return REG_EEND;					\
-    assert (p < pend);							\
-    emch = charptr_emchar ((const Bufbyte *) p);			\
-    INC_CHARPTR (p);							\
-    if (TRANSLATE_P (translate) && emch < 0x80)				\
-      emch = (Emchar) (unsigned char) RE_TRANSLATE (emch);		\
-  } while (0)
-
-#define PATFETCH_RAW_EXTENDED(emch)					\
-  do {if (p == pend) return REG_EEND;					\
-    assert (p < pend);							\
-    emch = charptr_emchar ((const Bufbyte *) p);			\
-    INC_CHARPTR (p);							\
-  } while (0)
-
-#define PATUNFETCH_EXTENDED DEC_CHARPTR (p)
-
-#define PATFETCH_EITHER(emch)			\
-  do {						\
-    if (has_extended_chars)			\
-      PATFETCH_EXTENDED (emch);			\
-    else					\
-      PATFETCH (emch);				\
-  } while (0)
-
-#define PATFETCH_RAW_EITHER(emch)		\
-  do {						\
-    if (has_extended_chars)			\
-      PATFETCH_RAW_EXTENDED (emch);		\
-    else					\
-      PATFETCH_RAW (emch);			\
-  } while (0)
-
-#define PATUNFETCH_EITHER			\
-  do {						\
-    if (has_extended_chars)			\
-      PATUNFETCH_EXTENDED (emch);		\
-    else					\
-      PATUNFETCH (emch);			\
-  } while (0)
-
-#else /* not MULE */
-
-#define PATFETCH_EITHER(emch) PATFETCH (emch)
-#define PATFETCH_RAW_EITHER(emch) PATFETCH_RAW (emch)
-#define PATUNFETCH_EITHER PATUNFETCH
-
-#endif /* MULE */
 
 /* If `translate' is non-null, return translate[D], else just D.  We
    cast the subscript to translate because some data is declared as
    `char *', to avoid warnings when a string constant is passed.  But
    when we use a character as a subscript we must make it unsigned.  */
-#define TRANSLATE(d) (TRANSLATE_P (translate) ? RE_TRANSLATE (d) : (d))
-
-#ifdef MULE
-
-#define TRANSLATE_EXTENDED_UNSAFE(emch) \
-  (TRANSLATE_P (translate) && emch < 0x80 ? RE_TRANSLATE (emch) : (emch))
-
+#ifndef TRANSLATE
+#define TRANSLATE(d) \
+  (RE_TRANSLATE_P (translate) \
+   ? (unsigned) RE_TRANSLATE (translate, (unsigned) (d)) : (d))
 #endif
 
+
 /* Macros for outputting the compiled pattern into `buffer'.  */
 
 /* If the buffer isn't allocated when it comes in, use this.  */
 #define INIT_BUF_SIZE  32
 
-/* Make sure we have at least N more bytes of space in buffer.  */
+/* Make sure we have at least N more bytes of space in buffer.	*/
 #define GET_BUFFER_SPACE(n)						\
-    while (buf_end - bufp->buffer + (n) > bufp->allocated)		\
+    while (b - bufp->buffer + (n) > bufp->allocated)			\
       EXTEND_BUFFER ()
 
 /* Make sure we have one more byte of buffer space and then add C to it.  */
 #define BUF_PUSH(c)							\
   do {									\
     GET_BUFFER_SPACE (1);						\
-    *buf_end++ = (unsigned char) (c);					\
+    *b++ = (unsigned char) (c);						\
   } while (0)
 
 
@@ -1600,23 +1689,23 @@
 #define BUF_PUSH_2(c1, c2)						\
   do {									\
     GET_BUFFER_SPACE (2);						\
-    *buf_end++ = (unsigned char) (c1);					\
-    *buf_end++ = (unsigned char) (c2);					\
+    *b++ = (unsigned char) (c1);					\
+    *b++ = (unsigned char) (c2);					\
   } while (0)
 
 
-/* As with BUF_PUSH_2, except for three bytes.  */
+/* As with BUF_PUSH_2, except for three bytes.	*/
 #define BUF_PUSH_3(c1, c2, c3)						\
   do {									\
     GET_BUFFER_SPACE (3);						\
-    *buf_end++ = (unsigned char) (c1);					\
-    *buf_end++ = (unsigned char) (c2);					\
-    *buf_end++ = (unsigned char) (c3);					\
+    *b++ = (unsigned char) (c1);					\
+    *b++ = (unsigned char) (c2);					\
+    *b++ = (unsigned char) (c3);					\
   } while (0)
 
 
 /* Store a jump with opcode OP at LOC to location TO.  We store a
-   relative address offset by the three bytes the jump itself occupies.  */
+   relative address offset by the three bytes the jump itself occupies.	 */
 #define STORE_JUMP(op, loc, to) \
   store_op1 (op, loc, (to) - (loc) - 3)
 
@@ -1624,19 +1713,17 @@
 #define STORE_JUMP2(op, loc, to, arg) \
   store_op2 (op, loc, (to) - (loc) - 3, arg)
 
-/* Like `STORE_JUMP', but for inserting.  Assume `buf_end' is the
-   buffer end.  */
+/* Like `STORE_JUMP', but for inserting.  Assume `b' is the buffer end.	 */
 #define INSERT_JUMP(op, loc, to) \
-  insert_op1 (op, loc, (to) - (loc) - 3, buf_end)
+  insert_op1 (op, loc, (to) - (loc) - 3, b)
 
-/* Like `STORE_JUMP2', but for inserting.  Assume `buf_end' is the
-   buffer end.  */
+/* Like `STORE_JUMP2', but for inserting.  Assume `b' is the buffer end.  */
 #define INSERT_JUMP2(op, loc, to, arg) \
-  insert_op2 (op, loc, (to) - (loc) - 3, arg, buf_end)
+  insert_op2 (op, loc, (to) - (loc) - 3, arg, b)
 
 
 /* This is not an arbitrary limit: the arguments which represent offsets
-   into the pattern are two bytes long.  So if 2^16 bytes turns out to
+   into the pattern are two bytes long.	 So if 2^16 bytes turns out to
    be too small, many things would have to change.  */
 #define MAX_BUF_SIZE (1L << 16)
 
@@ -1644,29 +1731,29 @@
 /* Extend the buffer by twice its current size via realloc and
    reset the pointers that pointed into the old block to point to the
    correct places in the new one.  If extending the buffer results in it
-   being larger than MAX_BUF_SIZE, then flag memory exhausted.  */
+   being larger than MAX_BUF_SIZE, then flag memory exhausted.	*/
 #define EXTEND_BUFFER()							\
-  do { 									\
-    re_char *old_buffer = bufp->buffer;				\
-    if (bufp->allocated == MAX_BUF_SIZE) 				\
+  do {									\
+    unsigned char *old_buffer = bufp->buffer;				\
+    if (bufp->allocated == MAX_BUF_SIZE)				\
       return REG_ESIZE;							\
     bufp->allocated <<= 1;						\
     if (bufp->allocated > MAX_BUF_SIZE)					\
-      bufp->allocated = MAX_BUF_SIZE; 					\
+      bufp->allocated = MAX_BUF_SIZE;					\
     bufp->buffer = (unsigned char *) realloc (bufp->buffer, bufp->allocated);\
     if (bufp->buffer == NULL)						\
       return REG_ESPACE;						\
     /* If the buffer moved, move all the pointers into it.  */		\
     if (old_buffer != bufp->buffer)					\
       {									\
-        buf_end = (buf_end - old_buffer) + bufp->buffer;		\
-        begalt = (begalt - old_buffer) + bufp->buffer;			\
-        if (fixup_alt_jump)						\
-          fixup_alt_jump = (fixup_alt_jump - old_buffer) + bufp->buffer;\
-        if (laststart)							\
-          laststart = (laststart - old_buffer) + bufp->buffer;		\
-        if (pending_exact)						\
-          pending_exact = (pending_exact - old_buffer) + bufp->buffer;	\
+	b = (b - old_buffer) + bufp->buffer;				\
+	begalt = (begalt - old_buffer) + bufp->buffer;			\
+	if (fixup_alt_jump)						\
+	  fixup_alt_jump = (fixup_alt_jump - old_buffer) + bufp->buffer;\
+	if (laststart)							\
+	  laststart = (laststart - old_buffer) + bufp->buffer;		\
+	if (pending_exact)						\
+	  pending_exact = (pending_exact - old_buffer) + bufp->buffer;	\
       }									\
   } while (0)
 
@@ -1684,7 +1771,7 @@
 /* Macros for the compile stack.  */
 
 /* Since offsets can go either forwards or backwards, this type needs to
-   be able to hold values from -(MAX_BUF_SIZE - 1) to MAX_BUF_SIZE - 1.  */
+   be able to hold values from -(MAX_BUF_SIZE - 1) to MAX_BUF_SIZE - 1.	 */
 typedef int pattern_offset_t;
 
 typedef struct
@@ -1710,51 +1797,97 @@
 #define COMPILE_STACK_EMPTY  (compile_stack.avail == 0)
 #define COMPILE_STACK_FULL  (compile_stack.avail == compile_stack.size)
 
-/* The next available element.  */
+/* The next available element.	*/
 #define COMPILE_STACK_TOP (compile_stack.stack[compile_stack.avail])
 
 
-/* Set the bit for character C in a bit vector.  */
-#define SET_LIST_BIT(c)				\
-  (buf_end[((unsigned char) (c)) / BYTEWIDTH]	\
-   |= 1 << (((unsigned char) c) % BYTEWIDTH))
+/* Structure to manage work area for range table.  */
+struct range_table_work_area
+{
+  int *table;			/* actual work area.  */
+  int allocated;		/* allocated size for work area in bytes.  */
+  int used;			/* actually used size in words.	 */
+  int bits;			/* flag to record character classes */
+};
+
+/* Make sure that WORK_AREA can hold more N multibyte characters.  */
+#define EXTEND_RANGE_TABLE_WORK_AREA(work_area, n)			  \
+  do {									  \
+    if (((work_area).used + (n)) * sizeof (int) > (work_area).allocated)  \
+      {									  \
+	(work_area).allocated += 16 * sizeof (int);			  \
+	if ((work_area).table)						  \
+	  (work_area).table						  \
+	    = (int *) realloc ((work_area).table, (work_area).allocated); \
+	else								  \
+	  (work_area).table						  \
+	    = (int *) malloc ((work_area).allocated);			  \
+	if ((work_area).table == 0)					  \
+	  FREE_STACK_RETURN (REG_ESPACE);				  \
+      }									  \
+  } while (0)
+
+#define SET_RANGE_TABLE_WORK_AREA_BIT(work_area, bit)		\
+  (work_area).bits |= (bit)
 
-#ifdef MULE
+/* These bits represent the various character classes such as [:alnum:]
+   in a charset's range table.  */
+#define BIT_ALNUM 0x1
+#define BIT_ALPHA 0x2
+#define BIT_WORD  0x4
+#define BIT_ASCII 0x8
+#define BIT_NONASCII 0x10
+#define BIT_GRAPH 0x20
+#define BIT_LOWER 0x40
+#define BIT_PRINT 0x80
+#define BIT_PUNCT 0x100
+#define BIT_SPACE 0x200
+#define BIT_UPPER 0x400
+#define BIT_UNIBYTE 0x800
+#define BIT_MULTIBYTE 0x1000
 
-/* Set the "bit" for character C in a range table. */
-#define SET_RANGETAB_BIT(c) put_range_table (rtab, c, c, Qt)
+/* Set a range (RANGE_START, RANGE_END) to WORK_AREA.  */
+#define SET_RANGE_TABLE_WORK_AREA(work_area, range_start, range_end)	\
+  do {									\
+    EXTEND_RANGE_TABLE_WORK_AREA ((work_area), 2);			\
+    (work_area).table[(work_area).used++] = (range_start);		\
+    (work_area).table[(work_area).used++] = (range_end);		\
+  } while (0)
 
-/* Set the "bit" for character c in the appropriate table. */
-#define SET_EITHER_BIT(c)			\
+/* Free allocated memory for WORK_AREA.	 */
+#define FREE_RANGE_TABLE_WORK_AREA(work_area)	\
   do {						\
-    if (has_extended_chars)			\
-      SET_RANGETAB_BIT (c);			\
-    else					\
-      SET_LIST_BIT (c);				\
+    if ((work_area).table)			\
+      free ((work_area).table);			\
   } while (0)
 
-#else /* not MULE */
+#define CLEAR_RANGE_TABLE_WORK_USED(work_area) ((work_area).used = 0, (work_area).bits = 0)
+#define RANGE_TABLE_WORK_USED(work_area) ((work_area).used)
+#define RANGE_TABLE_WORK_BITS(work_area) ((work_area).bits)
+#define RANGE_TABLE_WORK_ELT(work_area, i) ((work_area).table[i])
 
-#define SET_EITHER_BIT(c) SET_LIST_BIT (c)
 
-#endif
+/* Set the bit for character C in a list.  */
+#define SET_LIST_BIT(c)				      \
+  (b[((unsigned char) (c)) / BYTEWIDTH]		      \
+   |= 1 << (((unsigned char) c) % BYTEWIDTH))
 
 
 /* Get the next unsigned number in the uncompiled pattern.  */
-#define GET_UNSIGNED_NUMBER(num) 					\
+#define GET_UNSIGNED_NUMBER(num)					\
   { if (p != pend)							\
      {									\
-       PATFETCH (c); 							\
-       while (ISDIGIT (c)) 						\
-         { 								\
-           if (num < 0)							\
-              num = 0;							\
-           num = num * 10 + c - '0'; 					\
-           if (p == pend) 						\
-              break; 							\
-           PATFETCH (c);						\
-         } 								\
-       } 								\
+       PATFETCH (c);							\
+       while (ISDIGIT (c))						\
+	 {								\
+	   if (num < 0)							\
+	      num = 0;							\
+	   num = num * 10 + c - '0';					\
+	   if (p == pend)						\
+	      break;							\
+	   PATFETCH (c);						\
+	 }								\
+       }								\
     }
 
 #define CHAR_CLASS_MAX_LENGTH  6 /* Namely, `xdigit'.  */
@@ -1765,44 +1898,10 @@
     || STREQ (string, "alnum") || STREQ (string, "xdigit")		\
     || STREQ (string, "space") || STREQ (string, "print")		\
     || STREQ (string, "punct") || STREQ (string, "graph")		\
-    || STREQ (string, "cntrl") || STREQ (string, "blank"))
-
-static void store_op1 (re_opcode_t op, unsigned char *loc, int arg);
-static void store_op2 (re_opcode_t op, unsigned char *loc, int arg1, int arg2);
-static void insert_op1 (re_opcode_t op, unsigned char *loc, int arg,
-			unsigned char *end);
-static void insert_op2 (re_opcode_t op, unsigned char *loc, int arg1, int arg2,
-			unsigned char *end);
-static boolean at_begline_loc_p (re_char *pattern, re_char *p,
-				 reg_syntax_t syntax);
-static boolean at_endline_loc_p (re_char *p, re_char *pend, int syntax);
-static boolean group_in_compile_stack (compile_stack_type compile_stack,
-				       regnum_t regnum);
-static reg_errcode_t compile_range (re_char **p_ptr, re_char *pend,
-				    RE_TRANSLATE_TYPE translate,
-				    reg_syntax_t syntax,
-				    unsigned char *b);
-#ifdef MULE
-static reg_errcode_t compile_extended_range (re_char **p_ptr,
-					     re_char *pend,
-					     RE_TRANSLATE_TYPE translate,
-					     reg_syntax_t syntax,
-					     Lisp_Object rtab);
-#endif /* MULE */
-static boolean group_match_null_string_p (unsigned char **p,
-					  unsigned char *end,
-					  register_info_type *reg_info);
-static boolean alt_match_null_string_p (unsigned char *p, unsigned char *end,
-					register_info_type *reg_info);
-static boolean common_op_match_null_string_p (unsigned char **p,
-					      unsigned char *end,
-					      register_info_type *reg_info);
-static int bcmp_translate (const unsigned char *s1, const unsigned char *s2,
-			   REGISTER int len, RE_TRANSLATE_TYPE translate);
-static int re_match_2_internal (struct re_pattern_buffer *bufp,
-				re_char *string1, int size1,
-				re_char *string2, int size2, int pos,
-				struct re_registers *regs, int stop);
+    || STREQ (string, "cntrl") || STREQ (string, "blank")		\
+    || STREQ (string, "word")						\
+    || STREQ (string, "ascii") || STREQ (string, "nonascii")		\
+    || STREQ (string, "unibyte") || STREQ (string, "multibyte"))
 
 #ifndef MATCH_MAY_ALLOCATE
 
@@ -1817,32 +1916,33 @@
 
 /* Size with which the following vectors are currently allocated.
    That is so we can make them bigger as needed,
-   but never make them smaller.  */
+   but never make them smaller.	 */
 static int regs_allocated_size;
 
-static re_char **     regstart, **     regend;
-static re_char ** old_regstart, ** old_regend;
-static re_char **best_regstart, **best_regend;
+static const char **	 regstart, **	  regend;
+static const char ** old_regstart, ** old_regend;
+static const char **best_regstart, **best_regend;
 static register_info_type *reg_info;
-static re_char **reg_dummy;
+static const char **reg_dummy;
 static register_info_type *reg_info_dummy;
 
 /* Make the register vectors big enough for NUM_REGS registers,
-   but don't make them smaller.  */
+   but don't make them smaller.	 */
 
 static
-regex_grow_registers (int num_regs)
+regex_grow_registers (num_regs)
+     int num_regs;
 {
   if (num_regs > regs_allocated_size)
     {
-      RETALLOC_IF (regstart,	   num_regs, re_char *);
-      RETALLOC_IF (regend,	   num_regs, re_char *);
-      RETALLOC_IF (old_regstart,   num_regs, re_char *);
-      RETALLOC_IF (old_regend,	   num_regs, re_char *);
-      RETALLOC_IF (best_regstart,  num_regs, re_char *);
-      RETALLOC_IF (best_regend,	   num_regs, re_char *);
-      RETALLOC_IF (reg_info,	   num_regs, register_info_type);
-      RETALLOC_IF (reg_dummy,	   num_regs, re_char *);
+      RETALLOC_IF (regstart,	 num_regs, const char *);
+      RETALLOC_IF (regend,	 num_regs, const char *);
+      RETALLOC_IF (old_regstart, num_regs, const char *);
+      RETALLOC_IF (old_regend,	 num_regs, const char *);
+      RETALLOC_IF (best_regstart, num_regs, const char *);
+      RETALLOC_IF (best_regend,	 num_regs, const char *);
+      RETALLOC_IF (reg_info,	 num_regs, register_info_type);
+      RETALLOC_IF (reg_dummy,	 num_regs, const char *);
       RETALLOC_IF (reg_info_dummy, num_regs, register_info_type);
 
       regs_allocated_size = num_regs;
@@ -1871,32 +1971,41 @@
 
 /* Return, freeing storage we allocated.  */
 #define FREE_STACK_RETURN(value)		\
-  return (free (compile_stack.stack), value)
+  do {							\
+    FREE_RANGE_TABLE_WORK_AREA (range_table_work);	\
+    free (compile_stack.stack);				\
+    return value;					\
+  } while (0)
 
 static reg_errcode_t
-regex_compile (re_char *pattern, int size, reg_syntax_t syntax,
-	       struct re_pattern_buffer *bufp)
-{
-  /* We fetch characters from PATTERN here.  We declare these as int
-     (or possibly long) so that chars above 127 can be used as
-     array indices.  The macros that fetch a character from the pattern
-     make sure to coerce to unsigned char before assigning, so we won't
-     get bitten by negative numbers here. */
-  /* XEmacs change: used to be unsigned char. */
-  REGISTER EMACS_INT c, c1;
+regex_compile (pattern, size, syntax, bufp)
+     const char *pattern;
+     int size;
+     reg_syntax_t syntax;
+     struct re_pattern_buffer *bufp;
+{
+  /* We fetch characters from PATTERN here.  Even though PATTERN is
+     `char *' (i.e., signed), we declare these variables as unsigned, so
+     they can be reliably used as array indices.  */
+  register unsigned int c, c1;
 
   /* A random temporary spot in PATTERN.  */
-  re_char *p1;
+  const char *p1;
 
   /* Points to the end of the buffer, where we should append.  */
-  REGISTER unsigned char *buf_end;
+  register unsigned char *b;
 
   /* Keeps track of unclosed groups.  */
   compile_stack_type compile_stack;
 
   /* Points to the current (ending) position in the pattern.  */
-  re_char *p = pattern;
-  re_char *pend = pattern + size;
+#ifdef AIX
+  /* `const' makes AIX compiler fail.  */
+  char *p = pattern;
+#else
+  const char *p = pattern;
+#endif
+  const char *pend = pattern + size;
 
   /* How to translate the characters in the pattern.  */
   RE_TRANSLATE_TYPE translate = bufp->translate;
@@ -1917,10 +2026,10 @@
 
   /* Place in the uncompiled pattern (i.e., the {) to
      which to go back if the interval is invalid.  */
-  re_char *beg_interval;
+  const char *beg_interval;
 
   /* Address of the place where a forward jump should go to the end of
-     the containing expression.  Each alternative of an `or' -- except the
+     the containing expression.	 Each alternative of an `or' -- except the
      last -- ends with a forward jump of this sort.  */
   unsigned char *fixup_alt_jump = 0;
 
@@ -1929,6 +2038,9 @@
      number is put in the stop_memory as the start_memory.  */
   regnum_t regnum = 0;
 
+  /* Work area for range table of charset.  */
+  struct range_table_work_area range_table_work;
+
 #ifdef DEBUG
   DEBUG_PRINT1 ("\nCompiling pattern: ");
   if (debug)
@@ -1936,7 +2048,7 @@
       unsigned debug_count;
 
       for (debug_count = 0; debug_count < size; debug_count++)
-        putchar (pattern[debug_count]);
+	putchar (pattern[debug_count]);
       putchar ('\n');
     }
 #endif /* DEBUG */
@@ -1949,6 +2061,9 @@
   compile_stack.size = INIT_COMPILE_STACK_SIZE;
   compile_stack.avail = 0;
 
+  range_table_work.table = 0;
+  range_table_work.allocated = 0;
+
   /* Initialize the pattern buffer.  */
   bufp->syntax = syntax;
   bufp->fastmap_accurate = 0;
@@ -1962,6 +2077,14 @@
   /* Always count groups, whether or not bufp->no_sub is set.  */
   bufp->re_nsub = 0;
 
+#ifdef emacs
+  /* bufp->multibyte is set before regex_compile is called, so don't alter
+     it. */
+#else  /* not emacs */
+  /* Nothing is recognized as a multibyte character.  */
+  bufp->multibyte = 0;
+#endif
+
 #if !defined (emacs) && !defined (SYNTAX_TABLE)
   /* Initialize the syntax table.  */
    init_syntax_once ();
@@ -1971,20 +2094,20 @@
     {
       if (bufp->buffer)
 	{ /* If zero allocated, but buffer is non-null, try to realloc
-             enough space.  This loses if buffer's address is bogus, but
-             that is the user's responsibility.  */
-          RETALLOC (bufp->buffer, INIT_BUF_SIZE, unsigned char);
-        }
+	     enough space.  This loses if buffer's address is bogus, but
+	     that is the user's responsibility.	 */
+	  RETALLOC (bufp->buffer, INIT_BUF_SIZE, unsigned char);
+	}
       else
-        { /* Caller did not allocate a buffer.  Do it for them.  */
-          bufp->buffer = TALLOC (INIT_BUF_SIZE, unsigned char);
-        }
+	{ /* Caller did not allocate a buffer.	Do it for them.	 */
+	  bufp->buffer = TALLOC (INIT_BUF_SIZE, unsigned char);
+	}
       if (!bufp->buffer) FREE_STACK_RETURN (REG_ESPACE);
 
       bufp->allocated = INIT_BUF_SIZE;
     }
 
-  begalt = buf_end = bufp->buffer;
+  begalt = b = bufp->buffer;
 
   /* Loop through the uncompiled pattern until we're at the end.  */
   while (p != pend)
